import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;


/**
 * CTU Open Contest 2014
 * Problem solution: Karel the Robot
 * 
 * @author Martin Kacer
 */
public class karel {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() throws Exception {
		while (!st.hasMoreTokens()) {
			String line = input.readLine();
			if (line == null) return false;
			st = new StringTokenizer(line);
		}
		return true;
	}
	String nextToken() throws Exception {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() throws Exception {
		String s = nextToken();
		return (s == null) ? -1 : Integer.parseInt(s);
	}
	public static void main(String[] args) throws Exception {
		karel instance = new karel();
		while (instance.hasNextToken())
			instance.run();
	}
	
	static final int[] DX = {-1, 0, +1, 0}, DY = {0, -1, 0, +1};
	
	int r, s;
	char[][] map;
	char[] prog;
	boolean[][][][] visited, result;
	
	boolean isGood(int x, int y, int d, int p) {
		if (x < 0 || x >= r || y < 0 || y >= s) return false;
		if (visited[x][y][d][p]) return result[x][y][d][p];
		visited[x][y][d][p] = true;
		if (map[x][y] == 'E') return result[x][y][d][p] = true;
		int pp = (p+1)%prog.length;
		if (prog[p] == 'L') return result[x][y][d][p] = isGood(x, y, (d+1)%DX.length, pp);
		if (prog[p] == 'R') return result[x][y][d][p] = isGood(x, y, (d+3)%DX.length, pp);
		int xx = x + DX[d], yy = y + DY[d];
		return result[x][y][d][p] = (xx < 0 || xx >= r || yy < 0 || yy >= s || map[xx][yy] == 'X')
				? isGood(x, y, d, pp) : isGood(xx, yy, d, pp);
	}

	void run() throws Exception {
		r = nextInt(); s = nextInt();
		map = new char[r][];
		for (int i = 0; i < r; ++i) map[i] = nextToken().toCharArray();
		nextInt(); // ignore
		prog = nextToken().toCharArray();
		result = new boolean[r][s][DX.length][prog.length];
		visited = new boolean[r][s][DX.length][prog.length];
		int cnt = 0, all = 0;
		for (int i = 0; i < r; ++i) for (int j = 0; j < s; ++j) if (map[i][j] != 'X') {
			++all;
			if (isGood(i, j, 0, 0)) ++cnt;
		}
		System.out.println((all == cnt) ? "OK" : String.valueOf(cnt));
	}
}
