import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;


/**
 * CTU Open Contest 2014
 * Problem solution: Kolonie
 * 
 * We assume non-zero number of cells in every type and non-zero counts. (C<>0, S<>0)
 * 
 * @author Martin Kacer
 */
public class kolonie {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() throws Exception {
		while (!st.hasMoreTokens()) {
			String line = input.readLine();
			if (line == null) return false;
			st = new StringTokenizer(line);
		}
		return true;
	}
	String nextToken() throws Exception {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() throws Exception {
		String s = nextToken();
		return (s == null) ? -1 : Integer.parseInt(s);
	}
	public static void main(String[] args) throws Exception {
		kolonie instance = new kolonie();
		int prob = instance.nextInt();
		while (prob-->0)
			instance.run();
	}

	static final int[] NX = {0, 0, 1, -1, 1, -1}, NY = {1, -1, 0, 0, -1, 1};

	static class Point {
		int x, y;
		Point(int x, int y) { this.x = x; this.y = y; }
		public int hashCode() { return x * 500111 + y; }
		public boolean equals(Object obj) { return (obj instanceof Point) && ((Point)obj).x == x && ((Point)obj).y == y; }
	}
	
	static class OneType implements Comparable<OneType> {
		int cnt, cap = 0;
		public int compareTo(OneType other) { return other.cap - cap; }
	}

	void run() throws Exception {
		int p = nextInt(), t = nextInt(), sum = 0;
		OneType[] types = new OneType[t];
		for (int i = 0; i < t; ++i) {
			Set<Point> existing = new HashSet<Point>();
			OneType cur = types[i] = new OneType();
			cur.cnt = nextInt();
			int s = nextInt();
			while (s-->0) {
				int x = nextInt(), y = nextInt();
				cur.cap += 6;
				for (int d = 0; d < NX.length; ++d)
					if (existing.contains(new Point(x+NX[d], y+NY[d]))) cur.cap -= 2;
				existing.add(new Point(x, y));
			}
			sum += (cur.cap-=2) * cur.cnt;
		}
		p -= 2;
		if (sum < p) {
			System.out.println("Kapacita zakladny je pouze "+(sum+2)+" lidi.");
			return;
		}
		Arrays.sort(types);
		sum = 0;
		for (int i = 0; i < t; ++i) {
			OneType cur = types[i];
			sum += cur.cnt;
			p -= cur.cap * cur.cnt;
			if (p <= 0) {
				sum -= -p / cur.cap;
				break;
			}
		}
		System.out.println("Je treba "+sum+" celku.");
	}
}
