/*
 * CTU Open Contest 2014
 * Problem solution: Stavitel
 *
 * Solution from the 1998 contest.
 */

#include<stdio.h>
#include<string.h>
#include<stdlib.h>

#define MIN(A,B) ((A)<(B))?(A):(B)

#define MAXDIM 100

int front[MAXDIM];
int right[MAXDIM];

int Cmp(const void * ptr1, const void * ptr2)
{
  int a, b;
  a = *((const int *)ptr1);
  b = *((const int *)ptr2);
  if (a < b) return -1;
  if (a > b) return 1;
  return 0;
}

int main(void)
{
  int i, j, k, n, max, min;
  scanf("%d", &n);
  while (n--)
  {
    scanf("%d", &i);
    for (j = 0; j < i; ++j)
      scanf("%d", front + j);
    for (j = 0; j < i; ++j)
      scanf("%d", right + j);
    max = 0;
    for (j = 0; j < i; ++j)
      for (k = 0; k < i; ++ k)
        max += MIN(right[j], front[k]);
    if (i > 1)
    { 
      qsort(front, i, sizeof(int), Cmp);
      qsort(right, i, sizeof(int), Cmp);
    }
    min = j = k = 0;
    while ((j < i) && (k < i))
    {
      if (front[j] == right[k])
      {
        min += front[j++];
        ++k;
      } 
      else if (front[j] < right[k])
        min += front[j++];
      else
        min += right[k++];
    }
    while (j < i)
      min += front[j++];
    while (k < i)
      min += right[k++];
    printf("Minimalni budova obsahuje %d kostek, maximalni %d kostek.\n", min, max);
  }
  return 0;
}

