import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;


/**
 * CTU Open Contest 2014
 * Problem solution: Stavitel
 * 
 * @author Martin Kacer
 */
public class stavitel {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() throws Exception {
		while (!st.hasMoreTokens()) {
			String line = input.readLine();
			if (line == null) return false;
			st = new StringTokenizer(line);
		}
		return true;
	}
	String nextToken() throws Exception {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() throws Exception {
		String s = nextToken();
		return (s == null) ? -1 : Integer.parseInt(s);
	}
	public static void main(String[] args) throws Exception {
		stavitel instance = new stavitel();
		int prob = instance.nextInt();
		while (prob-->0)
			instance.run();
	}
	
	static final int MAX = 100;
	int[] x1 = new int[MAX], x2 = new int[MAX];

	void run() throws Exception {
		int n = nextInt();
		for (int i = 0; i < n; ++i) x1[i] = nextInt();
		for (int i = 0; i < n; ++i) x2[i] = nextInt();
		Arrays.sort(x1, 0, n); Arrays.sort(x2, 0, n);
		int min = 0, max = 0;
		for (int i = 0, j = 0; i < n || j < n; ) {
			if (i < n && j < n && x1[n-1-i] == x2[n-1-j]) {
				max += x1[n-1-i] * (i+j+1);
				min += x1[n-1-i++]; j++;
			} else if (j == n || (i < n && x1[n-1-i] > x2[n-1-j])) {
				max += x1[n-1-i] * j;
				min += x1[n-1-i++];
			} else {
				max += x2[n-1-j] * i;
				min += x2[n-1-j++];
			}
		}
		System.out.println("Minimalni budova obsahuje "+min+" kostek, maximalni "+max+" kostek.");
	}
}
